diff -Nur dovecot-2.0.beta5/AUTHORS dovecot-2.0.beta5+lemonade/AUTHORS
--- dovecot-2.0.beta5/AUTHORS	2009-08-25 08:10:16.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/AUTHORS	2010-06-11 13:41:34.000000000 -0500
@@ -13,6 +13,6 @@
 Vaclav Haisman <v.haisman@sh.cvut.cz> (src/lib/ioloop-kqueue.c,
   src/lib/ioloop-notify-kqueue.c)
 
-Portions Copyright (c) 2008 Apple Inc.  All rights reserved.
+Portions Copyright (c) 2008-2010 Apple Inc.  All rights reserved.
 
 Grepping 'Patch by' from ChangeLog shows up more people.
diff -Nur dovecot-2.0.beta5/COPYING dovecot-2.0.beta5+lemonade/COPYING
--- dovecot-2.0.beta5/COPYING	2009-08-25 08:10:16.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/COPYING	2010-06-11 13:12:14.000000000 -0500
@@ -75,3 +75,37 @@
  not be used in advertising or otherwise to promote the sale, use or other
  dealings in these Data Files or Software without prior written
  authorization of the copyright holder.
+
+CATENATE support in src/imap/cmd-append.c
+src/lib/lib-imap/imap-url.c
+src/lib/lib-imap/imap-url.h
+src/plugins/urlauth/*
+
+ Copyright (c) 2008-2010 Apple Inc. All rights reserved.
+ 
+ Redistribution and use in source and binary forms, with or without  
+ modification, are permitted provided that the following conditions  
+ are met:
+ 
+ 1.  Redistributions of source code must retain the above copyright  
+ notice, this list of conditions and the following disclaimer.
+ 2.  Redistributions in binary form must reproduce the above  
+ copyright notice, this list of conditions and the following  
+ disclaimer in the documentation and/or other materials provided  
+ with the distribution.
+ 3.  Neither the name of Apple Inc. ("Apple") nor the names of its  
+ contributors may be used to endorse or promote products derived  
+ from this software without specific prior written permission.
+ 
+ THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND  
+ ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,  
+ THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A  
+ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS  
+ CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  
+ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT  
+ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF  
+ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND  
+ ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  
+ OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  
+ OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF  
+ SUCH DAMAGE.
diff -Nur dovecot-2.0.beta5/configure.in dovecot-2.0.beta5+lemonade/configure.in
--- dovecot-2.0.beta5/configure.in	2010-05-09 13:34:12.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/configure.in	2010-06-11 13:12:14.000000000 -0500
@@ -2593,7 +2593,7 @@
 dnl **
 
 capability_banner="IMAP4rev1 LITERAL+ SASL-IR LOGIN-REFERRALS ID ENABLE"
-capability="$capability_banner SORT SORT=DISPLAY THREAD=REFERENCES THREAD=REFS MULTIAPPEND UNSELECT IDLE CHILDREN NAMESPACE UIDPLUS LIST-EXTENDED I18NLEVEL=1 CONDSTORE QRESYNC ESEARCH ESORT SEARCHRES WITHIN CONTEXT=SEARCH LIST-STATUS"
+capability="$capability_banner SORT SORT=DISPLAY THREAD=REFERENCES THREAD=REFS MULTIAPPEND CATENATE UNSELECT IDLE CHILDREN NAMESPACE UIDPLUS LIST-EXTENDED I18NLEVEL=1 CONDSTORE QRESYNC ESEARCH ESORT SEARCHRES WITHIN CONTEXT=SEARCH LIST-STATUS"
 AC_DEFINE_UNQUOTED(CAPABILITY_STRING, "$capability", IMAP capabilities)
 AC_DEFINE_UNQUOTED(CAPABILITY_BANNER_STRING, "$capability_banner", IMAP capabilities advertised in banner) 
 
@@ -2685,6 +2685,7 @@
 src/plugins/quota/Makefile
 src/plugins/imap-quota/Makefile
 src/plugins/trash/Makefile
+src/plugins/urlauth/Makefile
 src/plugins/virtual/Makefile
 src/plugins/zlib/Makefile
 src/plugins/imap-zlib/Makefile
diff -Nur dovecot-2.0.beta5/doc/example-config/conf.d/10-auth.conf dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/10-auth.conf
--- dovecot-2.0.beta5/doc/example-config/conf.d/10-auth.conf	2010-04-30 06:38:03.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/10-auth.conf	2010-06-11 13:19:41.000000000 -0500
@@ -87,6 +87,7 @@
 # Space separated list of wanted authentication mechanisms:
 #   plain login digest-md5 cram-md5 ntlm rpa apop anonymous gssapi otp skey
 #   gss-spnego
+# (APPLE) x-plain-submit lets submission server use PLAIN (for BURL) but nobody else
 # NOTE: See also disable_plaintext_auth setting.
 auth_mechanisms = plain
 
@@ -109,6 +110,7 @@
 
 #!include auth-deny.conf.ext
 #!include auth-master.conf.ext
+#!include auth-submit.conf.ext
 
 !include auth-system.conf.ext
 #!include auth-sql.conf.ext
diff -Nur dovecot-2.0.beta5/doc/example-config/conf.d/10-logging.conf dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/10-logging.conf
--- dovecot-2.0.beta5/doc/example-config/conf.d/10-logging.conf	2010-04-21 11:54:32.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/10-logging.conf	2010-06-11 13:20:09.000000000 -0500
@@ -38,6 +38,7 @@
 
 # Enable mail process debugging. This can help you figure out why Dovecot
 # isn't finding your mails.
+# (APPLE) This also helps troubleshoot URLFETCH issues.
 #mail_debug = no
 
 # Show protocol level SSL errors.
diff -Nur dovecot-2.0.beta5/doc/example-config/conf.d/90-plugin.conf dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/90-plugin.conf
--- dovecot-2.0.beta5/doc/example-config/conf.d/90-plugin.conf	2010-04-12 11:14:53.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/doc/example-config/conf.d/90-plugin.conf	2010-06-11 13:20:18.000000000 -0500
@@ -52,4 +52,8 @@
   # To let users LIST mailboxes shared by other users, Dovecot needs a
   # shared mailbox dictionary. For example:
   #acl_shared_dict = file:/var/lib/dovecot/shared-mailboxes
+
+  # (APPLE) Server name for GENURLAUTH/URLFETCH.  Can be host:port or
+  # just a FQHN.  Default is the system's real hostname.
+  #urlauth_hostport = 
 }
diff -Nur dovecot-2.0.beta5/src/auth/auth-request-handler.c dovecot-2.0.beta5+lemonade/src/auth/auth-request-handler.c
--- dovecot-2.0.beta5/src/auth/auth-request-handler.c	2010-05-03 17:31:33.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth-request-handler.c	2010-06-11 13:12:14.000000000 -0500
@@ -245,7 +245,8 @@
 
 		if (request->internal_failure)
 			auth_stream_reply_add(reply, "temp", NULL);
-		else if (request->master_user != NULL) {
+		else if (request->master_user != NULL ||
+			 request->submit_user != NULL) {  /* APPLE - urlauth */
 			/* authentication succeeded, but we can't log in
 			   as the wanted user */
 			auth_stream_reply_add(reply, "authz", NULL);
@@ -525,6 +526,19 @@
 					      "master_user",
 					      request->master_user);
 		}
+
+		/* APPLE - urlauth */
+		if (request->submit_user != NULL) {
+			auth_stream_reply_add(request->userdb_reply,
+					      "submit_user",
+					      request->submit_user);
+		}
+		if (request->anonymous_username != NULL) {
+			auth_stream_reply_add(request->userdb_reply,
+					      "anonymous_username",
+					      request->anonymous_username);
+		}
+
 		auth_stream_reply_import(reply,
 			auth_stream_reply_export(request->userdb_reply));
 		break;
diff -Nur dovecot-2.0.beta5/src/auth/auth-request.c dovecot-2.0.beta5+lemonade/src/auth/auth-request.c
--- dovecot-2.0.beta5/src/auth/auth-request.c	2010-05-03 16:01:32.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth-request.c	2010-06-11 13:12:14.000000000 -0500
@@ -171,6 +171,17 @@
 		auth_stream_reply_add(reply, "master_user",
 				      request->master_user);
 	}
+
+	/* APPLE - urlauth */
+        if (request->submit_user != NULL) {
+		auth_stream_reply_add(reply, "submit_user",
+				      request->submit_user);
+	}
+	if (request->anonymous_username != NULL) {
+		auth_stream_reply_add(reply, "anonymous_username",
+				      request->anonymous_username);
+	}
+
 	auth_stream_reply_add(reply, "original_username",
 			      request->original_username);
 
@@ -207,6 +218,13 @@
 		request->user = p_strdup(request->pool, value);
 	else if (strcmp(key, "master_user") == 0)
 		request->master_user = p_strdup(request->pool, value);
+
+	/* APPLE - urlauth */
+	else if (strcmp(key, "submit_user") == 0)
+		request->submit_user = p_strdup(request->pool, value);
+	else if (strcmp(key, "anonymous_username") == 0)
+		request->anonymous_username = p_strdup(request->pool, value);
+
 	else if (strcmp(key, "original_username") == 0)
 		request->original_username = p_strdup(request->pool, value);
 	else if (strcmp(key, "cert_username") == 0) {
@@ -233,7 +251,8 @@
 	else if (strcmp(key, "valid-client-cert") == 0)
 		request->valid_client_cert = TRUE;
 	else if (strcmp(key, "skip_password_check") == 0) {
-		i_assert(request->master_user !=  NULL);
+		i_assert(request->master_user !=  NULL ||
+			 request->submit_user !=  NULL);  /* APPLE - urlauth */
 		request->skip_password_check = TRUE;
 	} else if (strcmp(key, "mech") == 0)
 		request->mech_name = p_strdup(request->pool, value);
@@ -353,16 +372,29 @@
 			  result == PASSDB_RESULT_OK);
 }
 
-static bool auth_request_master_lookup_finish(struct auth_request *request)
+static bool auth_request_master_lookup_finish(struct auth_request *request,
+					      bool submit)  /* APPLE - urlauth */
 {
 	if (request->passdb_failure)
 		return TRUE;
 
 	/* master login successful. update user and master_user variables. */
+
+	/* APPLE - urlauth */
+	if (submit)
+		request->submit_user = request->user;
+	else	/* reduce code deltas */
+	request->master_user = request->user;
+
+	/* APPLE - urlauth */
+	if (submit)
+		auth_request_log_info(request, "passdb",
+				      "Submit user logging in as %s",
+				      request->requested_login_user);
+	else	/* reduce code deltas */
 	auth_request_log_info(request, "passdb", "Master user logging in as %s",
 			      request->requested_login_user);
 
-	request->master_user = request->user;
 	request->user = request->requested_login_user;
 	request->requested_login_user = NULL;
 
@@ -403,7 +435,20 @@
 		/* success */
 		if (request->requested_login_user != NULL) {
 			/* this was a master user lookup. */
-			if (!auth_request_master_lookup_finish(request))
+
+			/* APPLE - urlauth */
+			if (request->passdb->set->submit &&
+			    strcasecmp(request->service, "imap") != 0) {
+				auth_request_log_info(request, "passdb",
+				    "Attempted submit user login for "
+				    "non-imap service %s "
+				    "(trying to log in as user: %s)",
+				    request->service,
+				    request->requested_login_user);
+				*result = PASSDB_RESULT_USER_DISABLED;
+			} else	/* reduce code deltas */
+			if (!auth_request_master_lookup_finish(request,
+			    request->passdb->set->submit))	/* APPLE - urlauth */
 				return FALSE;
 		} else {
 			if (request->passdb->set->pass) {
@@ -1400,7 +1445,8 @@
 
 	if (request->skip_password_check) {
 		/* currently this can happen only with master logins */
-		i_assert(request->master_user != NULL);
+		i_assert(request->master_user != NULL ||
+			 request->submit_user != NULL);   /* APPLE - urlauth */
 		return 1;
 	}
 
@@ -1544,8 +1590,13 @@
 		str_append_c(str, ',');
 		str_append(str, ip);
 	}
-	if (auth_request->requested_login_user != NULL)
+	if (auth_request->requested_login_user != NULL) {
+		/* APPLE - urlauth */
+		if (auth_request->submit_user != NULL)
+			str_append(str, ",submit");
+		else	/* reduce code deltas */
 		str_append(str, ",master");
+	}
 	str_append(str, "): ");
 }
 
diff -Nur dovecot-2.0.beta5/src/auth/auth-request.h dovecot-2.0.beta5+lemonade/src/auth/auth-request.h
--- dovecot-2.0.beta5/src/auth/auth-request.h	2010-05-03 16:01:37.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth-request.h	2010-06-11 13:12:14.000000000 -0500
@@ -34,6 +34,11 @@
            has validated user as a valid master user, master_user is set to
            user and user is set to requested_login_user. */
         char *user, *requested_login_user, *master_user;
+
+	/* APPLE - urlauth */
+	char *submit_user;
+	char *anonymous_username;
+
 	/* original_username contains the username exactly as given by the
 	   client. this is needed at least with DIGEST-MD5 for password
 	   verification. however with master logins the master username has
diff -Nur dovecot-2.0.beta5/src/auth/auth-settings.c dovecot-2.0.beta5+lemonade/src/auth/auth-settings.c
--- dovecot-2.0.beta5/src/auth/auth-settings.c	2010-05-03 08:54:37.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth-settings.c	2010-06-11 13:12:14.000000000 -0500
@@ -104,6 +104,7 @@
 	DEF(SET_BOOL, deny),
 	DEF(SET_BOOL, pass),
 	DEF(SET_BOOL, master),
+	DEF(SET_BOOL, submit),				/* APPLE - urlauth */
 
 	SETTING_DEFINE_LIST_END
 };
@@ -113,7 +114,8 @@
 	.args = "",
 	.deny = FALSE,
 	.pass = FALSE,
-	.master = FALSE
+	.master = FALSE,
+	.submit = FALSE					/* APPLE - urlauth */
 };
 
 const struct setting_parser_info auth_passdb_setting_parser_info = {
diff -Nur dovecot-2.0.beta5/src/auth/auth-settings.h dovecot-2.0.beta5+lemonade/src/auth/auth-settings.h
--- dovecot-2.0.beta5/src/auth/auth-settings.h	2010-05-03 08:53:50.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth-settings.h	2010-06-11 13:12:14.000000000 -0500
@@ -10,6 +10,7 @@
 	bool deny;
 	bool pass;
 	bool master;
+	bool submit;					/* APPLE - urlauth */
 };
 
 struct auth_userdb_settings {
diff -Nur dovecot-2.0.beta5/src/auth/auth.c dovecot-2.0.beta5+lemonade/src/auth/auth.c
--- dovecot-2.0.beta5/src/auth/auth.c	2010-03-25 10:03:33.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/auth.c	2010-06-11 13:12:14.000000000 -0500
@@ -71,7 +71,8 @@
 
 	/* initialize passdbs first and count them */
 	for (passdb_count = 0, i = 0; i < db_count; i++) {
-		if (passdbs[i]->master)
+		if (passdbs[i]->master ||
+		    passdbs[i]->submit)			/* APPLE - urlauth */
 			continue;
 
 		auth_passdb_preinit(auth, passdbs[i], &auth->passdbs);
@@ -82,13 +83,24 @@
 		i_fatal("Last passdb can't have pass=yes");
 
 	for (i = 0; i < db_count; i++) {
-		if (!passdbs[i]->master)
+		if (!passdbs[i]->master &&
+		    !passdbs[i]->submit)		/* APPLE - urlauth */
 			continue;
 
 		if (passdbs[i]->deny)
-			i_fatal("Master passdb can't have deny=yes");
+					/* APPLE - urlauth */
+			i_fatal("Master/submit passdb can't have deny=yes");
+
+		/* APPLE - urlauth - Submit user has much less power than
+		   master user.  Forbid both master and submit in one passdb
+		   so that unaware services (pop3, managesieve) don't
+		   compromise security. */
+		if (passdbs[i]->master && passdbs[i]->submit)
+			i_fatal("Passdb can't have master=yes and submit=yes");
+
 		if (passdbs[i]->pass && passdb_count == 0) {
-			i_fatal("Master passdb can't have pass=yes "
+					/* APPLE - urlauth */
+			i_fatal("Master/submit passdb can't have pass=yes "
 				"if there are no passdbs");
 		}
 		auth_passdb_preinit(auth, passdbs[i], &auth->masterdbs);
diff -Nur dovecot-2.0.beta5/src/auth/db-checkpassword.c dovecot-2.0.beta5+lemonade/src/auth/db-checkpassword.c
--- dovecot-2.0.beta5/src/auth/db-checkpassword.c	2010-04-30 06:37:09.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/db-checkpassword.c	2010-06-11 13:12:14.000000000 -0500
@@ -121,6 +121,13 @@
 		env_put(t_strconcat("MASTER_USER=",
 				    request->master_user, NULL));
 	}
+
+	/* APPLE - urlauth */
+	if (request->submit_user != NULL) {
+		env_put(t_strconcat("SUBMIT_USER=",
+				    request->submit_user, NULL));
+	}
+
 	if (request->extra_fields != NULL) {
 		const char *fields =
 			auth_stream_reply_export(request->extra_fields);
diff -Nur dovecot-2.0.beta5/src/auth/mech-anonymous.c dovecot-2.0.beta5+lemonade/src/auth/mech-anonymous.c
--- dovecot-2.0.beta5/src/auth/mech-anonymous.c	2010-03-25 10:03:33.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/mech-anonymous.c	2010-06-11 13:12:14.000000000 -0500
@@ -20,6 +20,12 @@
 	request->user = p_strdup(request->pool,
 				 request->set->anonymous_username);
 
+	/* APPLE - urlauth - could add anonymous_username to every reply
+	   but it's only needed (for now) on anonymous auths; let's not
+	   inflate every reply if we don't have to */
+	request->anonymous_username =
+		p_strdup(request->pool, request->set->anonymous_username);
+
 	auth_request_success(request, NULL, 0);
 }
 
diff -Nur dovecot-2.0.beta5/src/auth/mech-plain.c dovecot-2.0.beta5+lemonade/src/auth/mech-plain.c
--- dovecot-2.0.beta5/src/auth/mech-plain.c	2010-01-24 17:16:12.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/auth/mech-plain.c	2010-06-11 13:12:14.000000000 -0500
@@ -6,9 +6,11 @@
 #include "passdb.h"
 #include "mech-plain-common.h"
 
+/* APPLE - urlauth */
 static void
-mech_plain_auth_continue(struct auth_request *request,
-			 const unsigned char *data, size_t data_size)
+mech_plain_auth_continue_submit(struct auth_request *request,
+				const unsigned char *data, size_t data_size,
+				bool submit)
 {
 	const char *authid, *authenid, *error;
 	char *pass;
@@ -54,6 +56,19 @@
                 auth_request_log_info(request, "plain",
                                       "login user: %s", error);
                 auth_request_fail(request);
+
+	/* APPLE - urlauth */
+	} else if (submit) {
+		if (request->requested_login_user != NULL &&
+		    *request->requested_login_user != '\0')
+			auth_request_verify_plain(request, pass,
+						  plain_verify_callback);
+		else {
+			auth_request_log_info(request, "x-plain-submit",
+					      "non-submit login");
+			auth_request_fail(request);
+		}
+
         } else {
                 auth_request_verify_plain(request, pass,
                                           plain_verify_callback);
@@ -64,6 +79,14 @@
 		safe_memset(pass, 0, strlen(pass));
 }
 
+/* APPLE - urlauth */
+static void
+mech_plain_auth_continue(struct auth_request *request,
+			 const unsigned char *data, size_t data_size)
+{
+	mech_plain_auth_continue_submit(request, data, data_size, FALSE);
+}
+
 static struct auth_request *mech_plain_auth_new(void)
 {
         struct auth_request *request;
@@ -86,3 +109,26 @@
 	mech_plain_auth_continue,
 	mech_generic_auth_free
 };
+
+/* APPLE - urlauth - rest of file
+   The X-PLAIN-SUBMIT mechanism mimics PLAIN but only for submit users
+   (and master users, since we can't tell the difference so early). */
+
+static void
+mech_submit_auth_continue(struct auth_request *request,
+			  const unsigned char *data, size_t data_size)
+{
+	mech_plain_auth_continue_submit(request, data, data_size, TRUE);
+}
+
+const struct mech_module mech_x_plain_submit = {
+	"X-PLAIN-SUBMIT",
+
+	.flags = MECH_SEC_PLAINTEXT,
+	.passdb_need = MECH_PASSDB_NEED_VERIFY_PLAIN,
+
+	mech_plain_auth_new,
+	mech_generic_auth_initial,
+	mech_submit_auth_continue,
+	mech_generic_auth_free
+};
diff -Nur dovecot-2.0.beta5/src/auth/mech.c dovecot-2.0.beta5+lemonade/src/auth/mech.c
--- dovecot-2.0.beta5/src/auth/mech.c	2010-03-25 10:03:33.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/mech.c	2010-06-11 13:12:14.000000000 -0500
@@ -64,6 +64,7 @@
 }
 
 extern const struct mech_module mech_plain;
+extern const struct mech_module mech_x_plain_submit;	/* APPLE - urlauth */
 extern const struct mech_module mech_login;
 extern const struct mech_module mech_apop;
 extern const struct mech_module mech_cram_md5;
@@ -158,6 +159,7 @@
 void mech_init(const struct auth_settings *set)
 {
 	mech_register_module(&mech_plain);
+	mech_register_module(&mech_x_plain_submit);	/* APPLE - urlauth */
 	mech_register_module(&mech_login);
 	mech_register_module(&mech_apop);
 	mech_register_module(&mech_cram_md5);
@@ -184,6 +186,7 @@
 void mech_deinit(const struct auth_settings *set)
 {
 	mech_unregister_module(&mech_plain);
+	mech_unregister_module(&mech_x_plain_submit);	/* APPLE - urlauth */
 	mech_unregister_module(&mech_login);
 	mech_unregister_module(&mech_apop);
 	mech_unregister_module(&mech_cram_md5);
diff -Nur dovecot-2.0.beta5/src/auth/passdb-blocking.c dovecot-2.0.beta5+lemonade/src/auth/passdb-blocking.c
--- dovecot-2.0.beta5/src/auth/passdb-blocking.c	2010-03-30 11:31:16.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/auth/passdb-blocking.c	2010-06-11 13:12:14.000000000 -0500
@@ -19,7 +19,8 @@
 
 	if (*args != NULL) {
 		i_assert(auth_stream_is_empty(request->extra_fields) ||
-			 request->master_user != NULL);
+			 request->master_user != NULL ||
+			 request->submit_user != NULL);   /* APPLE - urlauth */
 		auth_request_set_fields(request, args, NULL);
 	}
 }
@@ -79,7 +80,8 @@
 	struct auth_stream_reply *reply;
 
 	i_assert(auth_stream_is_empty(request->extra_fields) ||
-		 request->master_user != NULL);
+		 request->master_user != NULL ||
+		 request->submit_user != NULL);		/* APPLE - urlauth */
 
 	reply = auth_stream_reply_init(pool_datastack_create());
 	auth_stream_reply_add(reply, "PASSV", NULL);
@@ -121,7 +123,8 @@
 	struct auth_stream_reply *reply;
 
 	i_assert(auth_stream_is_empty(request->extra_fields) ||
-		 request->master_user != NULL);
+		 request->master_user != NULL ||
+		 request->submit_user != NULL);		/* APPLE - urlauth */
 
 	reply = auth_stream_reply_init(pool_datastack_create());
 	auth_stream_reply_add(reply, "PASSL", NULL);
diff -Nur dovecot-2.0.beta5/src/config/all-settings.c dovecot-2.0.beta5+lemonade/src/config/all-settings.c
--- dovecot-2.0.beta5/src/config/all-settings.c	2010-05-09 13:33:21.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/config/all-settings.c	2010-06-11 13:31:51.000000000 -0500
@@ -807,6 +807,7 @@
 	bool deny;
 	bool pass;
 	bool master;
+	bool submit;					/* APPLE - urlauth */
 };
 struct auth_userdb_settings {
 	const char *driver;
@@ -2307,6 +2308,7 @@
 	DEF(SET_BOOL, deny),
 	DEF(SET_BOOL, pass),
 	DEF(SET_BOOL, master),
+	DEF(SET_BOOL, submit),				/* APPLE - urlauth */
 
 	SETTING_DEFINE_LIST_END
 };
@@ -2315,7 +2317,8 @@
 	.args = "",
 	.deny = FALSE,
 	.pass = FALSE,
-	.master = FALSE
+	.master = FALSE,
+	.submit = FALSE					/* APPLE - urlauth */
 };
 const struct setting_parser_info auth_passdb_setting_parser_info = {
 	.defines = auth_passdb_setting_defines,
